#include <SPI.h>
#include "Adafruit_MAX31855.h"
#define MAXDO   5
#define MAXCS   4
#define MAXCLK  3
const float setTemp = 95.00;
const float lowerTemp = 60.00;
const float lowerTemp2 = 80.00;


// initialize the Thermocouple
Adafruit_MAX31855 thermocouple(MAXCLK, MAXCS, MAXDO);

void setup() {
  //Connection set-up
  pinMode(2,OUTPUT);

  //Heater set-up
  pinMode(6,OUTPUT);


 //Thermocouple set-up
  Serial.begin(9600);
 
  while (!Serial) delay(1); // wait for Serial on Leonardo/Zero, etc

  Serial.println("MAX31855 test");
  // wait for MAX chip to stabilize
  delay(500);
}

void loop() {
 
   double c = thermocouple.readCelsius();
//   on = digitalRead(1);
   if (isnan(c)) {
     Serial.println("Something wrong with thermocouple!");
   } else {
//     Serial.print("C = "); 
     Serial.println(c);
//     Serial.println(on);
   
     float temp = (c);
     digitalWrite(1,LOW);
   if (temp < lowerTemp){//Heat up constantly
    digitalWrite(6,HIGH);
    digitalWrite(2,LOW);
    delay(500);
   }else  if (temp < lowerTemp2){//slow down heating to prevent overshooting
    digitalWrite(6,HIGH);
    delay(125);
    digitalWrite(6,LOW);
    delay(375);
  }else if(temp<setTemp){
    digitalWrite(6,HIGH);
    delay(50);
    digitalWrite(6,LOW);
    delay(450);
   }else{
    digitalWrite(2,HIGH); // START PUMPING

//START PRE-INFUSION
//digitalWrite(6,HIGH);
delay(500);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);
//PRE-INFUSION END

//RE-HEAT BEFORE MAIN CYCLE
digitalWrite(2,LOW);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(250);
//digitalWrite(6,HIGH);
delay(250);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
delay(250);
if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(250);//1

digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(250);
//digitalWrite(6,HIGH);
delay(250);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
delay(250);
if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(250); //2

digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(250);
//digitalWrite(6,HIGH);
delay(250);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
delay(250);
if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(250); //3

digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(250);
//digitalWrite(6,HIGH);
delay(250);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
delay(250);
if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(250); //4

digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(250);
//digitalWrite(6,HIGH);
delay(250);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
delay(250);
if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(250); //5

digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(250);
//digitalWrite(6,HIGH);
delay(250);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
delay(250);
if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(250); //6

digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
  temp = (c);
delay(250);
if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(250); //6.5

//START OF MAIN CYCLE

  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//1


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//2


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//3


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//4


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//5


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//6


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//7


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//8


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//9


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//10


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//11


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//12


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
digitalWrite(6,LOW);
  c = thermocouple.readCelsius();
  Serial.println(c);
delay(500);//13


  c = thermocouple.readCelsius();
  temp = (c);
  Serial.println(c);
  if (temp<setTemp){
digitalWrite(6,HIGH);
}
delay(500);
  c = thermocouple.readCelsius();
  Serial.println(c);
  digitalWrite(6,LOW);
delay(750);//14.5

goto finish;

finish:
pinMode(6,LOW);
delay(500);
Serial.println("finish");
goto finish;
}



}
}
}
